import java.awt.Frame;
import java.awt.Label;
import java.awt.Color;
import java.awt.Button;
import java.awt.TextField;
import java.awt.TextArea;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class EcoFrame extends Frame implements ActionListener, Context {
    private TextField textClock = new TextField(60);        // ݎ\
    private TextArea textScreen = new TextArea(10, 60);     // xZ^[o
    private Button buttonLight = new Button("ƖON{^");      // Ɩgp{^
    private Button buttonAirConditioner = new Button("ON{^");    // 󒲎gp{^
    private Button buttonExit = new Button("I");         // I{^

    private State state = DayState.getInstance();           // ݂̏

    // RXgN^
    public EcoFrame(String title) {
        super(title);
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());
        // textClockzu
        add(textClock, BorderLayout.NORTH);
        textClock.setEditable(false);
        // textScreenzu
        add(textScreen, BorderLayout.CENTER);
        textScreen.setEditable(false);
        // plɃ{^i[
        Panel panel = new Panel();
        panel.add(buttonLight);
        panel.add(buttonAirConditioner);
        panel.add(buttonExit);
        // ̃plzu
        add(panel, BorderLayout.SOUTH);
        // \
        pack();
        show();
        // Xi[̐ݒ
        buttonLight.addActionListener(this);
        buttonAirConditioner.addActionListener(this);
        buttonExit.addActionListener(this);
    }
    // {^ꂽ炱ɗ
    public void actionPerformed(ActionEvent e) {
        System.out.println(e.toString());
        if (e.getSource() == buttonLight) {           // Ɩgp{^
            state.doLight(this);
        } else if (e.getSource() == buttonAirConditioner) {  // 󒲃{^
            state.doAirConditioner(this);
        } else if (e.getSource() == buttonExit) {   // I{^
            System.exit(0);
        } else {
            System.out.println("?");
        }
    }
    // ̐ݒ
    public void setClock(int hour) {
        String clockstring = "ݎ";
        if (hour < 10) {
            clockstring += "0" + hour + ":00";
        } else {
            clockstring += hour + ":00";
        }
        System.out.println(clockstring);
        textClock.setText(clockstring);
        state.doClock(this, hour);
    }
    // ԕω
    public void changeState(State state) {
        System.out.println(this.state + "" + state + "֏Ԃω܂B");
        this.state = state;
    }

    // ECO message
    public void showEcoMsg(String msg) {
        textScreen.append(" "+ msg + "\n");
    }
}
