import java.util.*;

public interface Entry {
    public void show();
}

class User implements Entry {
    private String name;

    public User(String name) {
	this.name = name;
    }

    public void show() {
	System.out.println(name);
    }
}

class Branch implements Entry {
    private String name;
    private Collection entries = new ArrayList();

    public Branch(String name) {
	this.name = name;
    }

    public void addEntry(Entry entry) {
	entries.add(entry);
    }

    public void show() {
	System.out.println("\n"+ name);
	System.out.println("----------------");

	Iterator iterator = entries.iterator();
	while(iterator.hasNext()) {
	    Entry entry = (Entry)iterator.next();
	    entry.show();
	}
    }

}

	


	
	
    
    