class Display {
    private static Display singleton = null;

    //private Constructor
    private Display(){};

    public static Display getInstance() {
	if (singleton == null){
	    singleton = new Display();
	}
	return singleton;
    }

    public void display(String msg) {
	System.out.println("Display: " + msg);
    }
}

class Main {
    public static void main(String[] args) {
	Display obj1 = Display.getInstance();
	Display obj2 = Display.getInstance();
	if (obj1 == obj2) {
	    System.out.println("obj1 == obj2");
	}
	obj1.display("obj1= "+obj1);
	obj2.display("obj2= "+obj2);
    }
}



    